---
title: 'Tutorial: Set a breakpoint'
slug: Tools/Debugger-API/Tutorial-Breakpoint
---
<div>{{ToolsSidebar}}</div>

<p>This page shows how you can try out the <a href="../Debugger-API" title="The Debugger API"><code>Debugger</code> API</a> yourself using Firefox’s Scratchpad. We use <code>Debugger</code> to set a breakpoint in a function, and then evaluate an expression whenever it is hit.</p>

<p>This tutorial was tested against Firefox 58 Beta and Nightly. It does not work in Firefox 57.</p>

<ol style="list-style-type: decimal;">
 <li>
  <p>Since the <code>Debugger</code> API is only available to privileged JavaScript code, you’ll need to use the Browser Content Toolbox to try it out. To do this, open the Firefox developer tools, click on the options gear at the upper right of the toolbox, and make sure that both “Enable browser chrome and add-on debugging toolboxes” and “Enable remote debugging” are checked. These are located at the bottom right of the options panel; you may need to scroll to see them. Once they’re checked, you can close the developer tools.</p>
 </li>
 <li>
  <p>Save the following text to an HTML file:</p>

  <pre class="language-html notranslate"><code>&lt;div onclick="report('the best div');"&gt;Click me!&lt;/div&gt;
&lt;div onclick="report('another great div');"&gt;Or me!&lt;/div&gt;
&lt;script&gt;
function report(what) {
  console.log('clicked: ' + what);
}
&lt;/script&gt;</code></pre>
 </li>
 <li>
  <p>Visit the HTML file in your browser, and open the Browser Content Toolbox by opening the Firefox menu, choosing “Web Developer”, and then “Browser Content Toolbox”. If that item doesn’t appear in the “Web Developer” menu, make sure you checked both boxes to enable the Browser Content Toolbox as explained in Step 1.</p>
 </li>
 <li>
  <p>Our example code is long enough that the best way to run it is to use the Scratchpad panel, which is not enabled by default. To enable it, click on the options gear at the upper right of the Browser Content Toolbox, and make sure the “Scratchpad” box in the “Default Developer Tools” section the left is checked. The Scratchpad panel should appear at the top of the Toolbox alongside the Console, Debugger, and Memory panels.</p>
 </li>
 <li>
  <p>Click on the Scratchpad panel and enter the following code:</p>

  <pre class="language-js notranslate"><code>Components.utils.import("resource://gre/modules/jsdebugger.jsm");
Components.utils.import("resource://gre/modules/Console.jsm");

// This defines 'Debugger' in this Scratchpad;
// it doesn't actually start debugging anything.
addDebuggerToGlobal(this);

// Create a 'Debugger' instance.
var dbg = new Debugger;

// Make the tab's top window a debuggee, and get a
// Debugger.Object referring to the window.
var windowDO = dbg.addDebuggee(tabs[0].content);

// Get a Debugger.Object referring to the window's `report`
// function.
var reportDO = windowDO.getOwnPropertyDescriptor('report').value;

// Set a breakpoint at the entry point of `report`.
reportDO.script.setBreakpoint(0, {
    hit: function (frame) {
        console.log('hit breakpoint in ' + frame.callee.name);
        console.log('what = ' + frame.eval('what').return);
    }
});

console.log('Finished setting breakpoint!');</code></pre>
 </li>
 <li>
  <p>In the Scratchpad, ensure that no text is selected, and press the “Run” button.</p>

  <p>Now, click on the text that says “Click me!” in the web page. This runs the <code>div</code> element’s <code>onclick</code> handler. When control reaches the start of the <code>report</code> function, <code>Debugger</code> calls the breakpoint handler’s <code>hit</code> method, passing a <code>Debugger.Frame</code> instance. The <code>hit</code> method logs the breakpoint hit to the browser content toolbox’s console. Then it evaluates the expression <code>what</code> in the given stack frame, and logs its result. The toolbox’s console now looks like this:</p>

  <p><img alt="The breakpoint handler’s console output" src="https://mdn.mozillademos.org/files/15721/console.png"></p>

  <p>You can also click on the text that says “Or me!”, to see <code>report</code> called from a different handler.</p>

  <p>If <code>Debugger</code> is unable to find the <code>report</code> function, or the console output does not appear, evaluate the expression <code>tabs[0].content.document.location</code> in the console to make sure that <code>tabs[0]</code> indeed refers to the HTML file you visited. If you have more than one tab visiting a <code>file:</code> URL, they all share a single content process, so you may need to use a different element of the array as the debuggee.</p>
 </li>
 <li>
  <p>Press “Run” in the Scratchpad again. Now, clicking on “Click me!” causes the breakpoint hit to be logged twice—one for each <code>Debugger</code> instance.</p>

  <p>Multiple <code>Debugger</code> instances can observe the same debuggee. Re-running the code in the Scratchpad creates a fresh <code>Debugger</code> instance, adds the same web page as its debuggee, and then sets a new breakpoint. When you click on the <code>div</code> element, both <code>Debugger</code>s’ breakpoints are hit, and both handlers run.</p>

  <p>This shows how any number of <code>Debugger</code>-based tools can observe a single web page simultaneously. In fact, you can use the Browser Content Toolbox’s Debugger panel to set its own breakpoint in <code>report</code>, and it will trigger along with the first two. Keep in mind, however, that when multiple Debuggers share a debuggee, the order in which their handlers run is not specified. If more than one tool tries to influence the debuggee’s behavior, their combined behavior could be unpredictable.</p>
 </li>
 <li>
  <p>Close the web page and the Browser Content Toolbox.</p>

  <p>Since both the Scratchpad’s global object and the debuggee window are now gone, the <code>Debugger</code> instances will be garbage collected, since they can no longer have any visible effect on Firefox’s behavior. The <code>Debugger</code> API tries to interact with garbage collection as transparently as possible; for example, if both a <code>Debugger.Object</code> instance and its referent are not reachable, they will both be collected, even while the <code>Debugger</code> instance to which the shadow belonged continues to exist.</p>
 </li>
</ol>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dd>js/src/doc/Debugger/Tutorial-Breakpoint.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:c8dd4bb69972b58e59fcbe6870499206463a5e330fda25f1214893595a1c01d0</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/ffa775dd5bd4">ffa775dd5bd4</a></dd>
</dl>
